<?php
class search_replace{
   var $find;
   var $replace;
   var $files;
   var $directories;
   var $include_subdir;
   var $ignore_lines;
   var $ignore_sep;
   var $occurences;
// #######################################
   var $replaced;
// #######################################
   var $search_function;
   var $last_error;
   function search_replace($find, $replace, $files, $directories = '', $include_subdir = 1, $ignore_lines = array()){
   $this->find            = $find;
   $this->replace         = $replace;
   $this->files           = $files;
   $this->directories     = $directories;
   $this->include_subdir  = $include_subdir;
   $this->ignore_lines    = $ignore_lines;
   $this->occurences      = 0;
// #######################################
   $this->replaced        = 0;
// #######################################
   $this->search_function = 'search';
   $this->last_error      = '';
}

function get_num_occurences(){
   return $this->occurences;
}
// #######################################
function get_num_replaced(){
   return $this->replaced;
}
function get_findstring(){
   return $this->find;
}
function get_replacestring(){
   return $this->replace;
}
// #######################################
function get_last_error(){
   return $this->last_error;
}
function set_find($find){
   $this->find = $find;
}
function set_replace($replace){
   $this->replace = $replace;
}
function set_files($files){
   $this->files = $files;
}
function set_directories($directories){
   $this->directories = $directories;
}
function set_include_subdir($include_subdir){
   $this->include_subdir = $include_subdir;
}
function set_ignore_lines($ignore_lines){
   $this->ignore_lines = $ignore_lines;
}
function set_search_function($search_function){
   switch($search_function){
       case 'normal': $this->search_function = 'search';
   return TRUE;
   break;
        case 'quick' : $this->search_function = 'quick_search';
   return TRUE;
   break;
        case 'preg'  : $this->search_function = 'preg_search';
   return TRUE;
   break;
         case 'ereg'  : $this->search_function = 'ereg_search';
   return TRUE;
   break;
         default      : $this->last_error      = 'Invalid search function specified';
   return FALSE;
   break;
   }
}

function search($filename){
   $occurences = 0;
// #######################################
   $replaced = 0;
// #######################################
   $file_array = file($filename);
   for($i=0; $i<count($file_array); $i++){
      if(count($this->ignore_lines) > 0){
         for($j=0; $j<count($this->ignore_lines);  $j++){
      if(substr($file_array[$i],0,strlen($this->ignore_lines[$j])) == $this->ignore_lines[$j]) continue 2;
      }
   }
   $occurences += count(explode($this->find, $file_array[$i])) - 1;
   $file_array[$i] = str_replace($this->find, $this->replace, $file_array[$i]);
   }
   if($occurences > 0) $return = array($occurences, implode('', $file_array)); else $return = FALSE;
    return $return;
}

function quick_search($filename){
    clearstatcache();
    $file  = fread($fp = fopen($filename, 'r'), filesize($filename)); fclose($fp);
    $occurences = count(explode($this->find, $file)) - 1;
    $file       = str_replace($this->find, $this->replace, $file);
    if($occurences > 0) $return = array($occurences, $file); else $return = FALSE;
    return $return;
}

function preg_search($filename){
    clearstatcache();
    $file       = fread($fp = fopen($filename, 'r'), filesize($filename)); fclose($fp);
    $occurences = count($matches = preg_split($this->find, $file)) - 1;
    $file       = preg_replace($this->find, $this->replace, $file);
    if($occurences > 0) $return = array($occurences, $file); else $return = FALSE;
     return $return;
}

function ereg_search($filename){
   clearstatcache();
   $file = fread($fp = fopen($filename, 'r'), filesize($filename)); fclose($fp);
   $occurences = count($matches = split($this->find, $file)) -1;
   $file       = ereg_replace($this->find, $this->replace, $file);
   if($occurences > 0) $return = array($occurences, $file); else $return = FALSE;
   return $return;
}

function writeout($filename, $contents){
if($fp = @fopen($filename, 'w')){
  flock($fp,2);
  fwrite($fp, $contents);
  flock($fp,3);
  fclose($fp);
// #######################################
$this->replaced += 1;
echo '<font size="2" color="blue"> * '.$filename.'  --> replaced!'.$replaced.'</font> <br>';
// #######################################
    }else{
    $this->last_error = 'Could not open file: '.$filename;

// #######################################
echo '<font size="2" color="red">Could not open file: '.$filename.' <br></font> ';
// #######################################
   }
}

function do_files($ser_func){
   if(!is_array($this->files)) $this->files = explode(',', $this->files);
   for($i=0; $i<count($this->files); $i++){
   if($this->files[$i] == '.' OR $this->files[$i] == '..') continue;
   if(is_dir($this->files[$i]) == TRUE) continue;
   $newfile = $this->$ser_func($this->files[$i]);
   if(is_array($newfile) == TRUE){
   $this->writeout($this->files[$i], $newfile[1]);
//  $this->replaced += 1;
   $this->occurences += $newfile[0];
        }
    }
}

function do_directories($ser_func){
    if(!is_array($this->directories)) $this->directories = explode(',', $this->directories);
    for($i=0; $i<count($this->directories); $i++){
    $dh = opendir($this->directories[$i]);
    while($file = readdir($dh)){
    if($file == '.' OR $file == '..') continue;
    if(is_dir($this->directories[$i].$file) == TRUE){
    if($this->include_subdir == 1){
    $this->directories[] = $this->directories[$i].$file.'/';

// #######################################
echo '<font size="2">'.$this->directories[$i].$file.'/ </font><br> ';
// #######################################
                                                        continue;
     }else{
     continue;
     }
  }
   $newfile = $this->$ser_func($this->directories[$i].$file);
   if(is_array($newfile) == TRUE){
   $this->writeout($this->directories[$i].$file, $newfile[1]);
   $this->occurences += $newfile[0];
         }
    }
  }
}

function do_search(){
 if($this->find != ''){
// #######################################
//echo 'Ersetzte <font color="green"><b>'.$this->find.'</b></font> durch <font color="green"><b>'.$this->replace.'</b></font> !<br>';
// #######################################
 if((is_array($this->files) AND count($this->files) > 0) OR $this->files != '') $this->do_files($this->search_function);
  if($this->directories != '')
    $this->do_directories($this->search_function);

// #######################################
echo '<br>--------------------------------------------------------';
echo '<br>Habe <font color="green"><b>'.$this->find.'</b></font> durch <font color="green"><b>'.$this->replace.'</b></font> ersetzt!';
echo '<br>Anzahl der gefundenen bereinstimmenden Stellen: '.$this->occurences.'<br>';
echo '<font color="blue">Anzahl der bearbeiteten Dateien: '.$this->replaced.'</font><br>';
// #######################################

    }
}
} // End of class
?>
