<?
/*
This script is provided to enable you to setup directories when you cannot
use the script provided in the main W-Nailer setup page.
Most likely you have downloaded this file, because when you clicked 'create',
you received a nasty 'Safe Mode' or similar error.

Copy this file to the 'root' directory where W-Nailer (nailer.php) is located.

Keep in mind, that in order for this script to work properly, you need to have
all the other W-Nailer files in place and configured properly! First read all the
comments and instructions before you start to ask questions.
If you still cannot solve your problem; please visit the W-Nailer forum at:

http://wnailer.vddh.com/forum

I'll be happy to help you!
*/

$server = 'www.yourserver.com'; // ftp server
$username = 'username'; // ftp username
$password = 'password'; // ftp password
$display_error = 'yes'; // set to 'no' to get rid of the error message!

include "scripts/nailer.inc.php";

$path = array('' . BASE_DIR . '');

/*
If the script gives a warning, you might have to change this path.
On one of my test servers, when I login using a regular FTP program,
I start in the /opt/guide/glazeni directory. This is not the directory where
nailer.php & this file are located.
To get to the correct directory, I have to click:

DOMAIN
HTML
test

You can enter values like this:

$path = array('DOMAIN', 'HTML', 'test', '' . BASE_DIR . '');

These values are CASE-SENSITIVE on Linux/Unix systems. This means that
'Html' means something different than 'html'. So pay attention!

This way, the script knows when it connects through FTP to which directory
it has to change before it starts!

Lets say when you login with FTP, you start in /home/Mike. But nailer.php is 
located in /home/Mike/html/wnailer. You would have to click:

html
wnailer

Then you would have to change $path to:

$path = array('html', 'wnailer', '' . BASE_DIR . '');



Keep in mind that PHP needs to have FTP support enabled!!
When you create a PHP page with phpinfo(); look for

--enable-ftp in the 'Configure Command' line at the top of the page.

NO --ENABLE-FTP MEANS THIS SCRIPT WILL NOT WORK!

Don't complain to me about it; complain to the provider of your server! :-)
*/
echo '<html>
<head>
<title>W-Nailer ' . VERSION . ', FTP Directory Creation</title>
<link rel="stylesheet" type="text/css" href="' . SCRIPTS . '/css.css">
<style>
.Submit {
border: none;
background-image: url(\'http://wnailer.vddh.com/pix/submit.gif\');
}
Body{
	font-family: arial
}
</style>
</head>

<body>
<center>';

// blank start page
if ( !$name && !$newdir ) {

	if ( $display_error == 'yes' ) {
		$ftp = ftp_connect($server) or die("Server not found"); // try to connect or die with an error
		$conn = ftp_login($ftp, $username, $password) or die("Login failed. Capslock on?"); // try to login or die with error
		$pwd = ftp_pwd($ftp) . '/';
		ftp_quit($ftp);
		if ( BASE_PATH <> $pwd ) echo '<table border=0 align=center><tr><td><font color="red">The BASE_PATH set in nailer.inc.php (' . BASE_PATH . ')<br>and the current working directory for ftp (' . $pwd .') are not the same.<br>I strongly advise you to correct this situation before you continue!<br><br>If you have set the correct directories in the "$path" variable in "dir_create.php"<br>you can ignore this message and continue.</font></td></tr></table><br><br>';
	}

	ksort($multi);
	$keys = array_keys($multi);
	$pulldown = "\n<option value=\"None\" selected>Select";

	for ($i = 0; $i < count($keys); $i++){
		if ( is_dir(BASE_DIR . '/' . $keys[$i]) ) {
			continue;
		}
		$pulldown .= "\n<option value=\"" . $keys[$i] . "\">" . ucwords($keys[$i]);
		$todo++;
	}

	if ( $todo == '1' ) {
		echo 'All galleries have been ceated or dirs.php is empty.';
	}
	else {
		echo '<form action="' . $PHP_SELF . '" method="POST"><select name="name" class="Select">' . $pulldown . '</select><input type="submit" name="newdir" value=" Cr.  Directory " class="Submit" title="Create Directories"></form>';
	}

	echo '<a href="' . UPLOAD_SCRIPT . '">Continue to upload page</a><br>';
	echo '<a href="' . NAILER_SCRIPT . '">Return to W-Nailer</a>';

} // end if

else {

	if( isset($newdir) ) { // check for empty entries
		if(!$name || $name == 'None' ) {
			echo 'Please enter a directory name!<br><br><a href="dir_create.php">Return to FTP page?</a>';
			exit;
		}

		$multi = array_keys($multi); // fetch array keys

		if ( !in_array($name, $multi) ) { // check for bogus entries
			echo 'Directory not found (invalid input)!<br><br><a href="dir_create.php">Return to FTP page?</a>';
			exit;
		}

		// try to connect
		$ftp = ftp_connect($server) or die("Server not found");

		// try to login
		$conn = ftp_login($ftp, $username, $password) or die("Login failed. Capslock on?");

		// chdir to the base gallery
		for ( $i = 0 ; $i < count($path) ; $i++ ) {
			ftp_chdir($ftp, $path[$i]) or die("failed to change into $path[$i] dir");
		}

		$needed_dirs = array($name, THUMBS, ERROR, COMMENTS, ORIGINALS);
		$fp = @fopen ("index.html", "r");

		for ( $i = 0 ; $i < count($needed_dirs) ; $i++ ) {
			// create the dir
			ftp_mkdir($ftp, $needed_dirs[$i]) or die("failed to create " . $needed_dirs[$i] . " dir");

			// and set the right properties
			$cmd="CHMOD 777 " . $needed_dirs[$i];
			ftp_site($ftp, $cmd) or die("failed to set " . $needed_dirs[$i] . " dir properties");

			if ( $i == 0 ) { // chdir for the main directory!
				echo $needed_dirs[$i] . "/ created<br>";
				ftp_chdir($ftp, $needed_dirs[$i]) or die("failed to change into " . $needed_dirs[$i] . " dir");
				@ftp_fput ( $ftp, "index.html", $fp, FTP_ASCII); // copy a bogus index.html file to prevent directory browsing
			}
			else {
				@ftp_chdir($ftp, $needed_dirs[$i]);
				@ftp_fput ( $ftp, "index.html", $fp, FTP_ASCII); // copy a bogus index.html file to prevent directory browsing
				@ftp_cdup($ftp);
				echo $name . "/" . $needed_dirs[$i] . "/ created<br>";
			}

		}

		// close the connection & filepointer
		@fclose($fp);
		ftp_quit($ftp);
	}

	echo '<br><a href="' . UPLOAD_SCRIPT . '?did=' . $name . '">Continue to upload page?</a><br>';
	echo '<a href="dir_create.php">Return to FTP page?</a>';

} // end else

/********************************************************************
*    W-Nailer 0.29 - 'Willem Nailer'
*********************************************************************
*    Removal of this text voids warranty... :)
*
*    Please leave this text in place, since it is only as much as credit for the creator 
*    of this script; /me: Willem.
*
*    This script is still in the testing fase. For any errors, comments, suggestions you
*    can contact me at the e-mail address below, or visit the forum.
*
*    (c)2001 by J.W.Veldhuizen <willem@vddh.com>, http://wnailer.vddh.com/forum
*
*    This file is part of W-Nailer.
*
*    W-Nailer is free software; you can redistribute it and/or modify it under the 
*    terms of the GNU General Public License as published by the Free Software
*    Foundation; either version 2 of the License, or (at your option) any later version.
*
*    W-Nailer is distributed in the hope that it will be useful, but WITHOUT ANY 
*    WARRANTY; without even the implied warranty of MERCHANTABILITY or
*    FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General Public License
*    for more details.
*
*    You should have received a copy of the GNU General Public License along with 
*    W-Nailer; if not, write to the Free Software Foundation, Inc., 59 Temple Place, 
*    Suite 330, Boston, MA  02111-1307  USA
********************************************************************/
?>
</center>
</body>
</html>